<a id="types-aiobotocore-organizations"></a>

# types-aiobotocore-organizations

[![PyPI - types-aiobotocore-organizations](https://img.shields.io/pypi/v/types-aiobotocore-organizations.svg?color=blue)](https://pypi.org/project/types-aiobotocore-organizations)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-organizations.svg?color=blue)](https://pypi.org/project/types-aiobotocore-organizations)
[![Docs](https://img.shields.io/readthedocs/types-aiobotocore.svg?color=blue)](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_organizations/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-organizations?color=blue)](https://pypistats.org/packages/types-aiobotocore-organizations)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[aiobotocore.Organizations 2.5.2](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/organizations.html#Organizations)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.14.5](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[types-aiobotocore](https://pypi.org/project/types-aiobotocore/) page and in
[types-aiobotocore-organizations docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_organizations/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [types-aiobotocore-organizations](#types-aiobotocore-organizations)
  - [How to install](#how-to-install)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `Organizations` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[organizations]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[organizations]'


# standalone installation
python -m pip install types-aiobotocore-organizations
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y types-aiobotocore-organizations
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[organizations]` in your environment:

```bash
python -m pip install 'types-aiobotocore[organizations]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `types-aiobotocore-lite[organizations]` in your environment:

```bash
python -m pip install 'types-aiobotocore-lite[organizations]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `types-aiobotocore` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `types-aiobotocore` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[organizations]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed
  `types-aiobotocore`

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `types-aiobotocore[organizations]` with services you use in your
  environment:

```bash
python -m pip install 'types-aiobotocore[organizations]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[organizations]` in your environment:

```bash
python -m pip install 'types-aiobotocore[organizations]'`
```

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `types-aiobotocore[organizations]` in your environment:

```bash
python -m pip install 'types-aiobotocore[organizations]'
```

Optionally, you can install `types-aiobotocore` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`OrganizationsClient` provides annotations for
`session.create_client("organizations")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_organizations import OrganizationsClient

session = get_session()
async with session.create_client("organizations") as client:
    client: OrganizationsClient
    # now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_organizations.paginator` module contains type annotations
for all paginators.

```python
from aiobotocore.session import get_session

from types_aiobotocore_organizations import OrganizationsClient
from types_aiobotocore_organizations.paginator import (
    ListAWSServiceAccessForOrganizationPaginator,
    ListAccountsPaginator,
    ListAccountsForParentPaginator,
    ListChildrenPaginator,
    ListCreateAccountStatusPaginator,
    ListDelegatedAdministratorsPaginator,
    ListDelegatedServicesForAccountPaginator,
    ListHandshakesForAccountPaginator,
    ListHandshakesForOrganizationPaginator,
    ListOrganizationalUnitsForParentPaginator,
    ListParentsPaginator,
    ListPoliciesPaginator,
    ListPoliciesForTargetPaginator,
    ListRootsPaginator,
    ListTagsForResourcePaginator,
    ListTargetsForPolicyPaginator,
)

session = get_session()
async with session.create_client("organizations") as client:
    client: OrganizationsClient

    # Explicit type annotations are optional here
    # Types should be correctly discovered by mypy and IDEs
    list_aws_service_access_for_organization_paginator: ListAWSServiceAccessForOrganizationPaginator = client.get_paginator(
        "list_aws_service_access_for_organization"
    )
    list_accounts_paginator: ListAccountsPaginator = client.get_paginator("list_accounts")
    list_accounts_for_parent_paginator: ListAccountsForParentPaginator = client.get_paginator(
        "list_accounts_for_parent"
    )
    list_children_paginator: ListChildrenPaginator = client.get_paginator("list_children")
    list_create_account_status_paginator: ListCreateAccountStatusPaginator = client.get_paginator(
        "list_create_account_status"
    )
    list_delegated_administrators_paginator: ListDelegatedAdministratorsPaginator = (
        client.get_paginator("list_delegated_administrators")
    )
    list_delegated_services_for_account_paginator: ListDelegatedServicesForAccountPaginator = (
        client.get_paginator("list_delegated_services_for_account")
    )
    list_handshakes_for_account_paginator: ListHandshakesForAccountPaginator = client.get_paginator(
        "list_handshakes_for_account"
    )
    list_handshakes_for_organization_paginator: ListHandshakesForOrganizationPaginator = (
        client.get_paginator("list_handshakes_for_organization")
    )
    list_organizational_units_for_parent_paginator: ListOrganizationalUnitsForParentPaginator = (
        client.get_paginator("list_organizational_units_for_parent")
    )
    list_parents_paginator: ListParentsPaginator = client.get_paginator("list_parents")
    list_policies_paginator: ListPoliciesPaginator = client.get_paginator("list_policies")
    list_policies_for_target_paginator: ListPoliciesForTargetPaginator = client.get_paginator(
        "list_policies_for_target"
    )
    list_roots_paginator: ListRootsPaginator = client.get_paginator("list_roots")
    list_tags_for_resource_paginator: ListTagsForResourcePaginator = client.get_paginator(
        "list_tags_for_resource"
    )
    list_targets_for_policy_paginator: ListTargetsForPolicyPaginator = client.get_paginator(
        "list_targets_for_policy"
    )
```

<a id="literals"></a>

### Literals

`types_aiobotocore_organizations.literals` module contains literals extracted
from shapes that can be used in user code for type checking.

```python
from types_aiobotocore_organizations.literals import (
    AccountJoinedMethodType,
    AccountStatusType,
    ActionTypeType,
    ChildTypeType,
    CreateAccountFailureReasonType,
    CreateAccountStateType,
    EffectivePolicyTypeType,
    HandshakePartyTypeType,
    HandshakeResourceTypeType,
    HandshakeStateType,
    IAMUserAccessToBillingType,
    ListAWSServiceAccessForOrganizationPaginatorName,
    ListAccountsForParentPaginatorName,
    ListAccountsPaginatorName,
    ListChildrenPaginatorName,
    ListCreateAccountStatusPaginatorName,
    ListDelegatedAdministratorsPaginatorName,
    ListDelegatedServicesForAccountPaginatorName,
    ListHandshakesForAccountPaginatorName,
    ListHandshakesForOrganizationPaginatorName,
    ListOrganizationalUnitsForParentPaginatorName,
    ListParentsPaginatorName,
    ListPoliciesForTargetPaginatorName,
    ListPoliciesPaginatorName,
    ListRootsPaginatorName,
    ListTagsForResourcePaginatorName,
    ListTargetsForPolicyPaginatorName,
    OrganizationFeatureSetType,
    ParentTypeType,
    PolicyTypeStatusType,
    PolicyTypeType,
    TargetTypeType,
    OrganizationsServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
)


def check_value(value: AccountJoinedMethodType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`types_aiobotocore_organizations.type_defs` module contains structures and
shapes assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_organizations.type_defs import (
    AcceptHandshakeRequestRequestTypeDef,
    AccountTypeDef,
    AttachPolicyRequestRequestTypeDef,
    CancelHandshakeRequestRequestTypeDef,
    ChildTypeDef,
    CloseAccountRequestRequestTypeDef,
    TagTypeDef,
    CreateAccountStatusTypeDef,
    CreateOrganizationRequestRequestTypeDef,
    OrganizationalUnitTypeDef,
    DeclineHandshakeRequestRequestTypeDef,
    DelegatedAdministratorTypeDef,
    DelegatedServiceTypeDef,
    DeleteOrganizationalUnitRequestRequestTypeDef,
    DeletePolicyRequestRequestTypeDef,
    DeregisterDelegatedAdministratorRequestRequestTypeDef,
    DescribeAccountRequestRequestTypeDef,
    DescribeCreateAccountStatusRequestRequestTypeDef,
    DescribeEffectivePolicyRequestRequestTypeDef,
    EffectivePolicyTypeDef,
    DescribeHandshakeRequestRequestTypeDef,
    DescribeOrganizationalUnitRequestRequestTypeDef,
    DescribePolicyRequestRequestTypeDef,
    DetachPolicyRequestRequestTypeDef,
    DisableAWSServiceAccessRequestRequestTypeDef,
    DisablePolicyTypeRequestRequestTypeDef,
    EmptyResponseMetadataTypeDef,
    EnableAWSServiceAccessRequestRequestTypeDef,
    EnablePolicyTypeRequestRequestTypeDef,
    EnabledServicePrincipalTypeDef,
    HandshakeFilterTypeDef,
    HandshakePartyTypeDef,
    HandshakeResourceTypeDef,
    ListAWSServiceAccessForOrganizationRequestListAWSServiceAccessForOrganizationPaginateTypeDef,
    ListAWSServiceAccessForOrganizationRequestRequestTypeDef,
    ListAccountsForParentRequestListAccountsForParentPaginateTypeDef,
    ListAccountsForParentRequestRequestTypeDef,
    ListAccountsRequestListAccountsPaginateTypeDef,
    ListAccountsRequestRequestTypeDef,
    ListChildrenRequestListChildrenPaginateTypeDef,
    ListChildrenRequestRequestTypeDef,
    ListCreateAccountStatusRequestListCreateAccountStatusPaginateTypeDef,
    ListCreateAccountStatusRequestRequestTypeDef,
    ListDelegatedAdministratorsRequestListDelegatedAdministratorsPaginateTypeDef,
    ListDelegatedAdministratorsRequestRequestTypeDef,
    ListDelegatedServicesForAccountRequestListDelegatedServicesForAccountPaginateTypeDef,
    ListDelegatedServicesForAccountRequestRequestTypeDef,
    ListOrganizationalUnitsForParentRequestListOrganizationalUnitsForParentPaginateTypeDef,
    ListOrganizationalUnitsForParentRequestRequestTypeDef,
    ListParentsRequestListParentsPaginateTypeDef,
    ListParentsRequestRequestTypeDef,
    ParentTypeDef,
    ListPoliciesForTargetRequestListPoliciesForTargetPaginateTypeDef,
    ListPoliciesForTargetRequestRequestTypeDef,
    PolicySummaryTypeDef,
    ListPoliciesRequestListPoliciesPaginateTypeDef,
    ListPoliciesRequestRequestTypeDef,
    ListRootsRequestListRootsPaginateTypeDef,
    ListRootsRequestRequestTypeDef,
    ListTagsForResourceRequestListTagsForResourcePaginateTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTargetsForPolicyRequestListTargetsForPolicyPaginateTypeDef,
    ListTargetsForPolicyRequestRequestTypeDef,
    PolicyTargetSummaryTypeDef,
    MoveAccountRequestRequestTypeDef,
    PolicyTypeSummaryTypeDef,
    PaginatorConfigTypeDef,
    RegisterDelegatedAdministratorRequestRequestTypeDef,
    RemoveAccountFromOrganizationRequestRequestTypeDef,
    ResourcePolicySummaryTypeDef,
    ResponseMetadataTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateOrganizationalUnitRequestRequestTypeDef,
    UpdatePolicyRequestRequestTypeDef,
    DescribeAccountResponseTypeDef,
    ListAccountsForParentResponseTypeDef,
    ListAccountsResponseTypeDef,
    ListChildrenResponseTypeDef,
    CreateAccountRequestRequestTypeDef,
    CreateGovCloudAccountRequestRequestTypeDef,
    CreateOrganizationalUnitRequestRequestTypeDef,
    CreatePolicyRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    PutResourcePolicyRequestRequestTypeDef,
    TagResourceRequestRequestTypeDef,
    CreateAccountResponseTypeDef,
    CreateGovCloudAccountResponseTypeDef,
    DescribeCreateAccountStatusResponseTypeDef,
    ListCreateAccountStatusResponseTypeDef,
    CreateOrganizationalUnitResponseTypeDef,
    DescribeOrganizationalUnitResponseTypeDef,
    ListOrganizationalUnitsForParentResponseTypeDef,
    UpdateOrganizationalUnitResponseTypeDef,
    ListDelegatedAdministratorsResponseTypeDef,
    ListDelegatedServicesForAccountResponseTypeDef,
    DescribeEffectivePolicyResponseTypeDef,
    ListAWSServiceAccessForOrganizationResponseTypeDef,
    ListHandshakesForAccountRequestListHandshakesForAccountPaginateTypeDef,
    ListHandshakesForAccountRequestRequestTypeDef,
    ListHandshakesForOrganizationRequestListHandshakesForOrganizationPaginateTypeDef,
    ListHandshakesForOrganizationRequestRequestTypeDef,
    HandshakeTypeDef,
    InviteAccountToOrganizationRequestRequestTypeDef,
    ListParentsResponseTypeDef,
    ListPoliciesForTargetResponseTypeDef,
    ListPoliciesResponseTypeDef,
    PolicyTypeDef,
    ListTargetsForPolicyResponseTypeDef,
    OrganizationTypeDef,
    RootTypeDef,
    ResourcePolicyTypeDef,
    AcceptHandshakeResponseTypeDef,
    CancelHandshakeResponseTypeDef,
    DeclineHandshakeResponseTypeDef,
    DescribeHandshakeResponseTypeDef,
    EnableAllFeaturesResponseTypeDef,
    InviteAccountToOrganizationResponseTypeDef,
    ListHandshakesForAccountResponseTypeDef,
    ListHandshakesForOrganizationResponseTypeDef,
    CreatePolicyResponseTypeDef,
    DescribePolicyResponseTypeDef,
    UpdatePolicyResponseTypeDef,
    CreateOrganizationResponseTypeDef,
    DescribeOrganizationResponseTypeDef,
    DisablePolicyTypeResponseTypeDef,
    EnablePolicyTypeResponseTypeDef,
    ListRootsResponseTypeDef,
    DescribeResourcePolicyResponseTypeDef,
    PutResourcePolicyResponseTypeDef,
)


def get_structure() -> AcceptHandshakeRequestRequestTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for
`aiobotocore` updates. It delivers drop-in type annotations for you and makes
sure that:

- All available `aiobotocore` services are covered.
- Each public class and method of every `aiobotocore` service gets valid type
  annotations extracted from `botocore` schemas.
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore`, `aiobotocore` and `aioboto3`
  libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.resource` calls
- Auto discovery of types for `session.client` and `session.resource` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`types-aiobotocore-organizations` version is the same as related `aiobotocore`
version and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/)
format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[aiobotocore docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_organizations/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
